Subject: Re: [PATCH wpan-next 1/6] net: ieee802154: Drop coordinator interface type

From: Miquel Raynal <[email-masked]>
Date: Wed, 15 Jun 2022 11:15:30 +0200

Hi Alexander,

[email-masked] wrote on Sat, 11 Jun 2022 08:05:31 -0400:

> Hi,
> 
> On Thu, Jun 9, 2022 at 11:44 AM Miquel Raynal <[email-masked]> wrote:
> >
> > Hi Alex,
> >  
> > > > >
> > > > >   - How is chosen the beacon order? Should we have a default value?
> > > > >     Should we default to 15 (not on a beacon enabled PAN)? Should we be
> > > > >     able to update this value during the lifetime of the PAN?
> > > > >  
> > > >
> > > > Is there no mib default value for this?  
> >
> > I didn't find anything. I suppose we can ask for that parameter at PAN
> > creation, but otherwise I'll keep a backward compatible value: 15,
> > which means that the PAN is not beacon enabled (like today, basically).
> >  
> 
> I hope it is not necessary to answer this question, see below.
> 
> > > >  
> > > > >   - The spec talks about the cluster topology, where a coordinator that
> > > > >     just associated to a PAN starts emitting beacons, which may enable
> > > > >     other devices in its range to ask to join the PAN (increased area
> > > > >     coverage). But then, there is no information about how the newly
> > > > >     added device should do to join the PAN coordinator which is anyway
> > > > >     out of range to require the association, transmit data, etc. Any
> > > > >     idea how this is supposed to work?
> > > > >  
> > > >
> > > > I think we should maybe add a feature for this later if we don't know
> > > > how it is supposed to work or there are still open questions and first
> > > > introduce the manual setup. After that, maybe things will become
> > > > clearer and we can add support for this part. Is this okay?  
> > >
> > > *I also think that this can be done in user space by a daemon by
> > > triggering netlink commands for scan/assoc/etc. (manual setup) and
> > > providing such functionality as mentioned by the spec (auto creation
> > > of pan, assoc with pan). Things which are unclear here are then moved
> > > to the user as the operations for scan/assoc/etc. will not be
> > > different or at least parameterized. The point here is that providing
> > > the minimum basic functionality should be done at first, then we can
> > > look at how to realize such handling (either in kernel or user space).  
> >
> > Actually this is none of the 802.15.4 MAC layer business. I believe
> > this is the upper layer duty to make this interoperability work,
> > namely, 6lowpan?  
> 
> I am not sure if I understand your answer, I meant that if
> "coordinator" or "PAN coordinator" depends on whatever, if somebody is
> running a "coordinator" software in the background on top of a coord
> interface.
> The kernel offers the functionality for scan/assoc/etc. (offers link
> quality, etc. _statistics_ and not _heuristic_) which will be used by
> this software to whatever the user defines to realize this behaviour
> as it is user specific.

Yes.

> Sure linux-wpan, should then provide at least a standard piece of
> software for it.
> 
> This has in my opinion nothing to do with 6lowpan.

I was referring to the cluster topology routing logic. The routing
logic to reach a device in a PAN that is not directly reachable by the
PAN coordinator is the responsibility of the layer 3 in the OSI model,
so I believe it's either 6lowpan's duty or even above.

Thanks,
Miquèl